{----------------------------------------------------------------------------}
{ NODEINFO.PAS  Automatischer ablaufgesteuerter Informationsabruf fuer Nodes }
{               und automatisierte Mailboxoperationen.                       }
{                                                                            }
{ Version V3.4  06.10.1993  Gerd Michael Ritter DL5FBD                       }
{----------------------------------------------------------------------------}

Program NODEINFO;

Uses CRT,DOS,V24;

{----------------------------------------------------------------------------}
{ Programmversion von NODEINFO.PAS                                           }
{----------------------------------------------------------------------------}

CONST  V='3.4';
      
VAR    Digi          : String;
       ConnectDigi   : String;
       Ein           : String;
       Aus           : String;
       Befehl        : String;
       Hilf          : String;
       TXFileEnd     : String;
       I             : Byte;
       ZLP           : LongInt;
       ZZP           : LongInt;
       IV            : LongInt;
       Test          : Integer;
       Ende          : Char;
       Prompt        : String;
       Reconnect     : String;
       Start         : Byte;

       Dir           : DirStr;
       IgnoreName    : NameStr;
       IgnoreExt     : ExtStr;
       ParaFile      : Text;
       ParaOk        : Boolean;
       CmdName       : String;
       RXName        : String;
       TXName        : String;
       RXLaenge      : LongInt;
       RXCount       : String[10];
       TXLaenge      : LongInt;
       TXLength      : String[10];
       TXCount       : String[10];
       CmdFile       : Text;
       RXFile        : Text;
       TXFile        : Text;
       RXData        : Boolean;
       TXData        : Boolean;
       IOFehler      : Byte;
       Abfrage       : LongInt;
       StrAbfrage    : String[10];
       Durchlaeufe   : LongInt;
       Zeile         : LongInt;
       SchleifeAktiv : Boolean;
       Schleife      : LongInt;
       Schleifenzeile: LongInt;
       Schleifenstart: LongInt;
       Schleifenende : LongInt;
       Schleifenindex: LongInt;
       FileForm      : Byte;
       FehlerAbbruch : Boolean;
       Linkfehler    : Boolean;
       Fehlermeldung : Boolean;
       AbbruchUrsache: String;

       SER           : Byte;
       HWDef         : Boolean;
       ADR           : Word;
       IRQ           : Byte;
       Baud          : Word;
       Bit           : Byte;
       PARI          : Char;
       Stop          : Byte;
       Hand          : Char;
       TXFreigabe    : Boolean;

       Jahr          : Word;
       Monat         : Word;
       Tag           : Word;
       WT            : Word;
       Stunde        : Word;
       Minute        : Word;
       Sekunde       : Word;
       ZS            : Word;
       GemerktesDatum: String[10];
       GemerkteZeit  : String[8];
       Pause         : LongInt;
       Makro         : Boolean;

{----------------------------------------------------------------------------}
{ Function Datum  Datum konstruieren                                         }
{----------------------------------------------------------------------------}

Function Datum:String;

VAR Teil :String[10];

BEGIN
  Teil:='';
  GetDate(Jahr,Monat,Tag,WT);
  STR(Tag,Hilf);
  IF Length(Hilf)=1 THEN Hilf:='0'+Hilf;
  Teil:=Teil+Hilf+'.';
  STR(Monat,Hilf);
  IF Length(Hilf)=1 THEN Hilf:='0'+Hilf;
  Teil:=Teil+Hilf+'.';
  STR(Jahr,Hilf);
  Teil:=Teil+Hilf;
  Datum:=Teil;
END;


{----------------------------------------------------------------------------}
{ Function Zeit  Zeit konstruieren                                           }
{----------------------------------------------------------------------------}

Function Zeit:String;

VAR Teil :String[10];

BEGIN
  Teil:='';
  GetTime(Stunde,Minute,Sekunde,ZS);    
  STR(Stunde,Hilf);
  IF Length(Hilf)=1 THEN Hilf:='0'+Hilf;
  Teil:=Teil+Hilf+':';
  STR(Minute,Hilf);
  IF Length(Hilf)=1 THEN Hilf:='0'+Hilf;
  Teil:=Teil+Hilf+':';
  STR(Sekunde,Hilf);
  IF Length(Hilf)=1 THEN Hilf:='0'+Hilf;
  Teil:=Teil+Hilf;
  Zeit:=Teil;
END;


{----------------------------------------------------------------------------}
{ Procedure WRITECENTER  Zentrierte Zeilenausgabe                            }
{----------------------------------------------------------------------------}

Procedure Writecenter(Zeile:String);

VAR X,Y: Byte;

BEGIN
  Y:=WhereY;
  GotoXY(1,Y);
  FOR X:=1 to 79 DO Write(' ');
  X:=(80-Length(Zeile)) DIV 2;
  IF Length(Zeile) > 79 THEN Zeile:=COPY(Zeile,1,79);
  GotoXY(X+1,Y);
  Write(Zeile);
END;


{----------------------------------------------------------------------------}
{ Procedure Status  Uhrzeit, Datum und Programmstatus ausgeben               }
{----------------------------------------------------------------------------}

Procedure Status(Text:String);

VAR X,Y  :Byte;
    TXT  :String[80];

BEGIN
  X:=WhereX;
  Y:=WhereY;
  TXT:=Datum+' '+Zeit+'  Status: '+Text;
  Window(1,1,80,25);
  GotoXY(1,23);
  WriteCenter(TXT);
  Window(1,3,80,21);
  GotoXY(X,Y);
END;


{----------------------------------------------------------------------------}
{ Procedure HeadLine  Kopfzeile in die Bildschirmmaske schreiben             }
{----------------------------------------------------------------------------}

Procedure HeadLine;

VAR X,Y :Byte;

BEGIN
  X:=WhereX;
  Y:=WhereY;
  Window(1,1,80,25);
  GotoXY(3,1);
  Str(IV,Hilf);
  WriteCenter('NODEINFO V'+V+' (c) DL5FBD   Node = '+Digi+'   Zeitabstand = '+Hilf+' Minuten');
  Window(1,3,80,21);
  GotoXY(X,Y);
END;


{----------------------------------------------------------------------------}
{ Procedure FileErr  Abbruchbedingung bei Fehler in Files setzen             }
{----------------------------------------------------------------------------}

Procedure FileErr(Name:String);

BEGIN
  Abbruchursache:='Dateifehler beim Zugriff auf '+Name;
  FehlerAbbruch:=True;
END;


{----------------------------------------------------------------------------}
{ Vorhandene Zeichen von RS232 lesen                                         }
{----------------------------------------------------------------------------}

Procedure V24Input;

VAR    Test   :Char;

BEGIN
  While V24Count>0 DO        {Auf RS232 empfangene Zeichen einlesen}
    BEGIN
      TEST:=V24Read;
      IF (Test<>#10) AND (Test<>#13) AND (Test<>#7) THEN Write(Test);
      IF Test=#13 THEN Writeln;
    END;
END;


{----------------------------------------------------------------------------}
{ Zeichen unter Sendehandshakebeachtung ausgeben                             }
{----------------------------------------------------------------------------}

PROCEDURE V24HSWrite(Zeichen:CHAR);

BEGIN
  REPEAT
    TXFreigabe:=TXReady;
    IF TXFreigabe THEN
      BEGIN
        V24Write(Zeichen);                {Zeichen auf RS232 ausgeben}
        Delay(ZZP);
      END;
  UNTIL TXFreigabe;
END;


{----------------------------------------------------------------------------}
{ Zeichenkette auf RS232 ausgeben                                            }
{----------------------------------------------------------------------------}

PROCEDURE V24STWrite(ZKETTE:STRING);

VAR I    :BYTE;

BEGIN
  IF ZKette<>'' THEN FOR I:=1 TO LENGTH(ZKETTE) DO V24HSWrite(ZKETTE[I]);
  V24HSWrite(CHR(13));
  Delay(ZLP);                     {Zeilenschutzzeit abwarten}
END;


{----------------------------------------------------------------------------}
{ Ermittlung der Laenge einer Datei                                          }
{----------------------------------------------------------------------------}

FUNCTION FILELAEN(Name:String):LongInt;

VAR Test   :File of Byte;  {Testfile}
    Laenge :LongInt;       {Dateilaenge}
    
BEGIN
  Assign (Test,Name);
  {$I-} Reset (Test); {$I+}
  IF IOResult=0 THEN 
    BEGIN
      FILELAEN:=FileSize(Test);
      Close (Test);
    END
  ELSE FILELAEN:=0;
END;


{----------------------------------------------------------------------------}
{ Filenamen und Typ aus Laufwerks-Pfad-Dateispezifikation entnehmen          }
{----------------------------------------------------------------------------}

Function FILENAME(Alles:String):String;

VAR Name   :String [12];
    I      :Byte;

BEGIN
  Name:='';
  I   :=Length(Alles);
  While (I > 0) AND (Alles[I] <> '\') AND (Alles[I] <> ':') DO
    BEGIN
      Name:=Alles[I]+Name;
      DEC(I);
    END;
  FILENAME:=Name;
END;


{----------------------------------------------------------------------------}
{ RS232-Eingaben auf Zeichenkette absuchen ohne Zusatzfunktionen             }
{----------------------------------------------------------------------------}

Procedure WAITSTR(Check:String);

VAR Line :String[80];
    Test :Char;

BEGIN
  {RS232 zeichenweise lesen und auf Zeichenkette ueberpruefen}
  Line:='';
  REPEAT
    IF V24Count > 0 THEN
      BEGIN
        IF Length(Line)=80 THEN Line:=COPY(Line,2,Length(Line)-1);
        Test:=V24Read;
        IF Test=#13 THEN
          BEGIN
            Line:='';
            Writeln;
          END
        ELSE IF Test<>#10 THEN
          BEGIN
            Line:=Line+Test;
            IF Test<>#7 THEN Write(Test);
          END;
      END;
  While KeyPressed DO Test:=ReadKey;
  UNTIL (POS(Check,Line)>0) OR (Test=#27);

  {Rest der Zeile bis zum CR auslesen}
  Test:=#0;
  Delay (ZLP);
  While (V24Count>0) AND (Test<>#13) DO
    BEGIN
      Test:=V24Read;
      IF Test<>#7 THEN Write(Test);
      IF Test=#13 THEN Writeln;
    END;
END;


{----------------------------------------------------------------------------}
{ RS232-Eingaben auf Zeichenkette absuchen, Abbruchbedingungen pruefen sowie }
{ Sendedatei und Empfangsdatei waehrend des Suchvorgangs bearbeiten          }
{----------------------------------------------------------------------------}

Procedure Waitfor(Position:Byte;Zeile:String);

VAR Uebereinstimmung : Boolean;
    Test             : String;
    Fehler           : String;
    Ein              : Char;
    TXLine           : String;

BEGIN
  {Im Fehlerzustand sofort abbrechen!}
  IF Fehlerabbruch OR Linkfehler THEN EXIT;

  Uebereinstimmung := False;
  AbbruchUrsache   := '';
  Test             := '';

  REPEAT
    {Bei geoeffnetem Sendedatenfile Daten zeilenweise ausgeben}
    IF TXData THEN 
      BEGIN
        {$I-} Readln(TXFile,TXLine); {$I+}
        IF IOResult <> 0 THEN
          BEGIN
            FileErr(TXName);
            EXIT;
          END;
        V24STWrite(TXLine);
        IF EOF(TXFile) OR Linkfehler OR Fehlerabbruch THEN
          BEGIN
            IF EOF(TXFile) AND (TXFileEnd<>'') THEN V24StWrite(TXFileEnd);
            Close(TXFile);
            TXData:=False;
            Status('Kommandodatei wird abgearbeitet.');
          END
        ELSE
          BEGIN
            Str(TXLaenge,TXCount);
            Aus:='TX-File: '+FILENAME(TXName)+'  TX: ';
            Aus:=Aus+TXCount+'/'+TXLength+' Byte';
            TXLaenge:=TXLaenge+Length(TXLine)+2;
            Status(Aus);
          END;
        Delay(ZLP);
        V24Input;
      END;

    {Abfrage auf den Suchbegriff}
    IF V24Count>0 THEN
      BEGIN
        IF Length(Test)=255 THEN Test:=COPY(Test,2,Length(Test)-1);
        Ein:=V24Read;
        IF (EIN<>#10) AND (Ein<>#13) AND (Ein<>#7) THEN
          BEGIN
            Test:=Test+Ein;
            Write(Ein);
          END;
        IF Ein=#13 THEN
          BEGIN
            Writeln;
            IF RXData THEN
              BEGIN
                CASE FileForm OF
                  3: BEGIN
                       FOR I:=1 TO Length(Test) DO Test[I]:=UpCase(Test[I]);
                       IF Test<>'' THEN Writeln(RXFile,Test);
                       RXLaenge:=RXLaenge+Length(Test)+2;
                     END;
                  2: BEGIN
                       FOR I:=1 TO Length(Test) DO Test[I]:=UpCase(Test[I]);
                       Writeln(RXFile,Test);
                       RXLaenge:=RXLaenge+Length(Test)+2;
                     END;
                  1: IF Test<>'' THEN 
                       BEGIN
                         Writeln(RXFile,Test);
                         RXLaenge:=RXLaenge+Length(Test)+2;
                       END;
                  0: BEGIN
                       Writeln(RXFile,Test);
                       RXLaenge:=RXLaenge+Length(Test)+2;
                     END;
                END;
                IF IOResult<>0 THEN
                  BEGIN
                    FileErr(RXName);
                    EXIT;
                  END
                ELSE
                  BEGIN
                    Str(RXLaenge,RXCount);
                    Aus:='RX-File: '+FILENAME(RXName)+'  RX: ';
                    Aus:=Aus+RXCount+' Byte';
                    Status(Aus);
                  END;
              END;
            Test:='';
          END;
      END;

    {Abfrage auf Benutzerabbruch durch Eingabe von <ESC>}
    While KeyPressed DO IF ReadKey=Chr(27) THEN
       BEGIN
         FehlerAbbruch :=True;
         Abbruchursache:='Benutzer hat NODEINFO beendet!';
       END;

    {Abfrage auf Uebereinstimmung in Vergleichsstring und Position}
    IF Position=0 THEN Uebereinstimmung:=(POS(Zeile,Test)>Position)
                  ELSE Uebereinstimmung:=(POS(Zeile,Test)=Position);

    {Abfrage moeglicher Verbindungsfehler mit Abbruch der Abfrage}
    IF (NOT Uebereinstimmung) THEN
      BEGIN
        {Fehlermeldungen von der TNC-Software}
        IF POS('BUSY fm '+ConnectDigi,Test)>0           THEN LinkFehler:=True;
        IF POS('DISCONNECTED fm '+ConnectDigi,Test)>0   THEN LinkFehler:=True;
        IF POS('LINK FAILURE with '+ConnectDigi,Test)>0 THEN LinkFehler:=True;
        {Reconnect-Fehlerpruefung bei Hop to Hop Connects}
        IF Reconnect='*' THEN
          BEGIN
            Fehler:=Test;
            FOR I:=1 to Length(Fehler) DO Fehler[I]:=UpCase(Fehler[I]); 
          IF POS('RECONNECTED TO',Fehler)>0 THEN LinkFehler:=True;
          END
        ELSE IF Reconnect<>'' THEN
          BEGIN
            IF POS(Reconnect,Test)>0 THEN LinkFehler:=True;
          END;
        {Weitere Bearbeitung der Fehlerzustaende}
        IF (FehlerAbbruch OR LinkFehler) AND (AbbruchUrsache='') THEN
          AbbruchUrsache:=Test;
        IF (FehlerAbbruch OR LinkFehler) AND RXData AND (NOT Fehlermeldung) THEN
          BEGIN
            Aus:='*** Abbruch: '+Datum+' '+Zeit+' '+AbbruchUrsache;
            Writeln(RXFile,Aus);
            IF IOResult<>0 THEN
              BEGIN
                FileErr(RXName);
                EXIT;
              END;
            IF LinkFehler THEN Writeln(RXFile);
            IF IOResult<>0 THEN
              BEGIN
                FileErr(RXName);
                EXIT;
              END;
            Fehlermeldung:=True;
          END;
      END;

  UNTIL Uebereinstimmung OR FehlerAbbruch OR LinkFehler;

  {Rest der Zeile einlesen und ausgeben nachdem Prompt/Abbruch erkannt}
  Delay(ZLP);
  Ein:=#0;
  While (V24Count>0) AND (Ein<>#13) DO
    BEGIN
      Ein:=V24Read;
      IF Ein<>#7 THEN Write(Ein);
      IF Fehlerabbruch OR Linkfehler THEN Abbruchursache:=Abbruchursache+Ein;
      IF Ein=#13 THEN Writeln;
    END;
END;


{-------------------------------------------------------------------------}
{Function HEX   Umwandlung einer Dezimalziffer in einen Hexwertstring     }
{-------------------------------------------------------------------------}

FUNCTION HEX(DEZI:LongInt):STRING;

VAR DIVI    :LongInt;
    REST    :Byte;
    HIS     :String;

BEGIN
  {Negative Werte sind unzulaeesig}
  IF DEZI < 0 THEN
    BEGIN
      FehlerAbbruch :=True;
      Abbruchursache:='Negative Werte fuer $L und $+ unzulaessig!';
      EXIT;
    END;
  {0 direkt bearbeiten}
  IF DEZI = 0 THEN
    BEGIN
      HEX:='0';
      EXIT;
    END;
  {Positive Werte mit Hornerschema umwandeln}
  HIS:='';
  While DEZI <> 0 DO
    BEGIN
      DIVI:=DEZI;
      DEZI:=DIVI DIV 16;
      REST:=(DIVI-DEZI*16);
      IF REST<10 THEN HIS:=CHR(REST+$30)+HIS 
                 ELSE HIS:=CHR(REST+$41-10)+HIS;
    END;
  HEX:=HIS;
END;


{----------------------------------------------------------------------------}
{Function Makroauswertung  Fuegt Makroinhalte ein z.B. Datum, Uhrzeit        }
{----------------------------------------------------------------------------}

Function Makroauswertung(Inhalt:String):String;

VAR P: Byte;

BEGIN
  {Wenn Mkroausfuehrung gesperrt dann beenden}
  IF NOT Makro THEN
    BEGIN
      Makroauswertung:=Inhalt;
      EXIT;
    END;

  {Uhrzeitkennung $T(ime) durch aktuelle Uhrzeit ersetzen}
  REPEAT
    P:=POS('$T',Inhalt);
    IF P>0 THEN
        Inhalt:=COPY(Inhalt,1,P-1)+Zeit+COPY(Inhalt,P+2,Length(Inhalt)-P+1);
  UNTIL P=0;

  {Datumskennung $D(ate) durch aktuelles Datum ersetzen}
  REPEAT
    P:=POS('$D',Inhalt);
    IF P>0 THEN
        Inhalt:=COPY(Inhalt,1,P-1)+Datum+COPY(Inhalt,P+2,Length(Inhalt)-P+1);
  UNTIL P=0;

  {Uhrzeitkennung $t(ime) durch Uhrzeit aus ***SAVETIME ersetzen}
  REPEAT
    P:=POS('$t',Inhalt);
    IF P>0 THEN
      Inhalt:=COPY(Inhalt,1,P-1)+GemerkteZeit
             +COPY(Inhalt,P+2,Length(Inhalt)-P+1);
  UNTIL P=0;

  {Datumskennung $d(ate) durch Datum aus ***SAVEDATE ersetzen}
  REPEAT
    P:=POS('$d',Inhalt);
    IF P>0 THEN
      Inhalt:=COPY(Inhalt,1,P-1)+GemerktesDatum
             +COPY(Inhalt,P+2,Length(Inhalt)-P+1);
  UNTIL P=0;

  {Schleifenindex dezimal einfuegen}
  REPEAT
    P:=POS('$l',Inhalt);
    IF P>0 THEN
      BEGIN
        STR(Schleifenindex,Hilf);
        Inhalt:=COPY(Inhalt,1,P-1)+Hilf
               +COPY(Inhalt,P+2,Length(Inhalt)-P+1);
      END;
  UNTIL P=0;

  {Schleifenindex hexadezmal einfuegen}
  REPEAT
    P:=POS('$L',Inhalt);
    IF P>0 THEN
      BEGIN
        Inhalt:=COPY(Inhalt,1,P-1)+Hex(Schleifenindex)
               +COPY(Inhalt,P+2,Length(Inhalt)-P+1);
      END;
  UNTIL P=0;

  {Schleifenindex fuer 7PLUS-Filetyp hexadezmal einfuegen}
  REPEAT
    P:=POS('$+',Inhalt);
    IF P>0 THEN
      BEGIN
        Hilf:=Hex(Schleifenindex);
        {Anpassung fuer 7PLUS Filetypen .P01-.P09}
        IF Length(Hilf)=1 THEN Hilf:='0'+Hilf;
        Inhalt:=COPY(Inhalt,1,P-1)+Hilf
               +COPY(Inhalt,P+2,Length(Inhalt)-P+1);
      END;
  UNTIL P=0;

  {Abfrageanzahl fuer Linkstatusabfragen einfuegen}
  REPEAT
    P:=POS('$C',Inhalt);
    IF P>0 THEN
      BEGIN
        STR(Abfrage,StrAbfrage);
        Inhalt:=COPY(Inhalt,1,P-1)+StrAbfrage
             +COPY(Inhalt,P+2,Length(Inhalt)-P+1);
      END;
  UNTIL P=0;
  Makroauswertung:=Inhalt;
END;


{----------------------------------------------------------------------------}
{ Procedure CmdErr  Abbruch bei Syntaxfehler in Ablaufsteuerdatei            }
{----------------------------------------------------------------------------}

Procedure CmdErr;

BEGIN
  AbbruchUrsache:='Syntaxfehler in Ablaufsteuerdatei!';
  FehlerAbbruch:=True;
END;


{----------------------------------------------------------------------------}
{ Procedure Ablauf  Befehlsinterpreter zur Steuerung des Abfragevorganges    }
{----------------------------------------------------------------------------}

Procedure Ablauf(Eingabe:String);

VAR Data :String;
    P    :Byte;

BEGIN
  {Befehl fuer eventuelle Fehlerbehandlung merken}
  IF (NOT Fehlerabbruch) AND (NOT Linkfehler) THEN Befehl:=Eingabe;

  {Steuerbefehl in Grossbuchstaben zur eindeutigen Erkennung umwandeln}
  P:=1;
  While (Eingabe[P]<>':') AND (P<=Length(Eingabe)) DO
    BEGIN
      Eingabe[P]:=Upcase(Eingabe[P]);
      INC(P);
    END;

  {Auf Steuerbefehl ueberpruefen}
  P:=POS('***',Eingabe);
  IF P=0 THEN CmdErr
  ELSE
    BEGIN
      {Warten auf speziellen Eingabeprompt}
      P:=POS('***WAITFOR',Eingabe);
      IF P>0 THEN
        BEGIN
          P:=POS(':',Eingabe);
          Eingabe:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          P:=POS(',',Eingabe);
          IF P>0 THEN
            BEGIN
              VAL(Copy(Eingabe,1,P-1),Start,Test);
              IF Test<>0 THEN CmdErr;
              Prompt:=COPY(Eingabe,P+1,Length(Eingabe)-P);
              WaitFor(Start,Prompt);
              EXIT;
            END
          ELSE CmdErr;
        END;

      {Definition des abzufragenden Node und Ausgabe in Kopfzeile}
      P:=POS('***INFONODE',Eingabe);
      IF P>0 THEN
        BEGIN
          P:=POS(':',Eingabe);
          Digi:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          IF Digi='' THEN CmdErr;
          HeadLine;
          EXIT;
        END;

      {Definition des Einstiegsdigipeater zur Linkfehlerueberwachung}
      P:=POS('***CONNNODE',Eingabe);
      IF P>0 THEN
        BEGIN
          P:=POS(':',Eingabe);
          ConnectDigi:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          IF ConnectDigi='' THEN CmdErr;
          EXIT;
        END;

      {Ausgabe einer Datenzeile zum TNC}
      P:=POS('***SENDDATA',Eingabe);
      IF P>0 THEN
        BEGIN
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          IF Data='' THEN CmdErr;
          Data:=Makroauswertung(Data);
          V24STWrite(Data);
          EXIT;
        END;

      {Ausgabe einer Kommandozeile zum TNC}
      P:=POS('***SENDCMD',Eingabe);
      IF P>0 THEN
        BEGIN
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          IF Data='' THEN CmdErr;
          Data:=Makroauswertung(Data);
          V24STWrite(#27+Data);
          EXIT;
        END;

      {Datenspeicherung in File einschalten}
      P:=POS('***RXFILE',Eingabe);
      IF (P>0) AND (NOT RXData)
               AND (NOT FehlerAbbruch)
               AND (NOT LinkFehler) THEN
        BEGIN
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          IF Data='' THEN CMDErr;
          RXName:=Makroauswertung(Data);
          Assign(RXFile,RXName);
          {$I-} Reset (RXFile); {$I+}
          IF IOResult=0 THEN
            BEGIN
              {$I-} Append(RXFile); {$I+}
              IF IOResult<>0 THEN
                BEGIN
                  FileErr(RXName);
                  EXIT;
                END;
            END
          ELSE
            BEGIN
              {$I-} Rewrite(RXFile); {$I+}
              IF IOResult<>0 THEN
                BEGIN
                  FileErr(RXName);
                  EXIT;
                END;
            END;
          RXLaenge:=FILELAEN(RXName);
          Str(RXLaenge,RXCount);
          Aus:='RX-File: '+FILENAME(RXName)+'  RX: ';
          Aus:=Aus+RXCount+' Byte';
          Status(Aus);
          RXData:=True;
        END;

      {Daten aus File aussenden}
      P:=POS('***TXFILE',Eingabe);
      IF (P>0) AND (NOT TXData)
               AND (NOT FehlerAbbruch)
               AND (NOT LinkFehler) THEN
        BEGIN
          TXFileEnd:='';
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          IF Data='' THEN CmdErr;
          P:=POS(',',Data);
          IF P>0 THEN
            BEGIN
              TXFileEnd:=Copy(Data,P+1,Length(Data)-P);
              Data:=Copy(Data,1,P-1);
            END;
          TXName:=Makroauswertung(Data);
          Assign(TXFile,TXName);
          {$I-} Reset (TXFile); {$I+}
          IF IOResult=0 THEN
            BEGIN
              TXLaenge:=FILELAEN(TXName);
              Str(TXLaenge,TXLength);
              TXLaenge:=0;
              Str(TXLaenge,TXCount);
              Aus:='TX-File: '+FILENAME(TXName)+'  TX: ';
              Aus:=Aus+TXCount+'/'+TXLength+' Byte';
              Status(Aus);
              TXdata:=True;
            END
          ELSE FileErr(TXName);
        END;

      {Schliessen der Empfangsdatei}
      P:=POS('***RXCLOSE',Eingabe);
      IF (P>0) AND RXData THEN 
        BEGIN
          Close(RXFile);
          Status('Kommandodatei wird abgearbeitet.');
          RXData:=False;
        END;

      {Steuerung des abzuspeichernden Datenformats}
      {***FILEFORM :0  - alles unveraendert lassen}
      {***FILEFORM :1  - Leerzeilen ausfiltern    }
      {***FILEFORM :2  - Alles in Grossbuchstaben }
      {***FILEFORM :3  - 1 und 2 gleichzeitig     }
      P:=POS('***FILEFORM',Eingabe);
      IF (P>0) THEN
        BEGIN
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          VAL(Data,FileForm,Test);
          IF (Test<>0) OR (FileForm<0) OR (FileForm>3) THEN CmdErr; 
          EXIT;
        END;

      {Deklaration einer zyklischen Abarbeitung im Abstand von x Minuten}
      P:=POS('***FOREVER',Eingabe);
      IF (P>0) THEN
        BEGIN
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          VAL(Data,IV,Test);
          IF Test>0 THEN CMDErr;
          INC(Durchlaeufe);
          HeadLine;
          EXIT;
        END;

      {Definition des Reconnect Abbruchstring}
      P:=POS('***RECONNECT',Eingabe);
      IF (P>0) THEN
        BEGIN
          P:=POS(':',Eingabe);
          Reconnect:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          EXIT;
        END;

      {Ausgabe einer Kommentarzeile in das RXFile und Umsetzung von}
      {Makroanweisungen in der Datenzeile}
      P:=POS('***RXWRITE',Eingabe);
      IF (P>0) AND RXData THEN
        BEGIN
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          Data:=Makroauswertung(Data);
          IF POS('***RXWRITELN',Eingabe)>0 THEN Writeln(RXFile,Data)
                                           ELSE Write(RXFile,Data);
          EXIT;
        END;

      {Aktuelles Datum fuer Logdateifuehrung merken}
      P:=POS('***SAVEDATE',Eingabe);
      IF P>0 THEN GemerktesDatum:=Datum;

      {Aktuelle Uhrzeit fuer Logdateifuehrung merken}
      P:=POS('***SAVETIME',Eingabe);
      IF P>0 THEN GemerkteZeit:=Zeit;

      {Makrobearbeitung ein/ausschalten}
      P:=POS('***MAKRO',Eingabe);
      IF P>0 THEN Makro:=(Eingabe[Length(Eingabe)]='1');

      {Initialisierung eines DOFOR Zaehlschleifenblock}
      P:=POS('***DOFOR',Eingabe);
      IF (P>0) THEN
        BEGIN
          IF SchleifeAktiv THEN CMDErr;
          P:=POS(':',Eingabe);
          Data:=COPY(Eingabe,P+1,Length(Eingabe)-P);
          P:=POS(',',Data);
          Hilf:=COPY(Data,1,P-1);
          VAL(Hilf,Schleifenstart,Test);
          IF Test>0 THEN CMDErr;
          Hilf:=COPY(Data,P+1,Length(Data)-P);
          VAL(Hilf,Schleifenende,Test);
          IF Test>0 THEN CMDErr;
          IF Schleifenstart > Schleifenende THEN CMDErr;
          Schleifenzeile:=Zeile;
          Schleifenindex:=Schleifenstart;
          SchleifeAktiv:=True;
          EXIT;
        END;

      {Abschluss eines DOFOR Zaehlschleifenblock mit DOEND}
      P:=POS('***DOEND',Eingabe);
      IF P>0 THEN
        BEGIN
          IF NOT SchleifeAktiv THEN CMDErr;
          IF Schleifenindex<Schleifenende THEN
            BEGIN
              {$I-} 
              Reset (CmdFile); 
              FOR Schleife:=1 to Schleifenzeile DO Readln(CmdFile,Ein);
              {$I+}
              Zeile:=Schleifenzeile;
              INC(Schleifenindex);
            END
          ELSE SchleifeAktiv:=False;
          EXIT;
        END;
    END;
END;


{----------------------------------------------------------------------------}
{ NODEINFO Hauptprogramm                                                     }
{----------------------------------------------------------------------------}

BEGIN
  {Bildschirmausgaben bis zur Einstellung in NODEINFO.CFG}
  {ueber die VIDEO-BIOS Aufrufe durchfuehren}
  DirectVideo:=False;

  {Startpfad von NODEINFO fuer Filezugriff ermitteln}
  FSplit(ParamStr(0),Dir,IgnoreName,IgnoreExt);

  {Ueberpruefung der Kommandozeile auf erforderliche Eingaben}
  IF ParamCount=0 THEN
    BEGIN
      ClrScr;
      Writeln(' NODEINFO - Ablaufgesteuerte Abfrage von Nodedaten fuer Sysops.');
      Writeln('   V',V);
      Writeln('            Aufruf: NODEINFO <Ablaufsteuerdatei>');
      Writeln;
      HALT;
    END;
  IF ParamCount=1 THEN CmdName:=ParamStr(1);
  IF ParamCount>1 THEN
    BEGIN
      Writeln;
      Writeln('*** NODEINFO-Abbruch: Parameterangabe undefiniert!');
      Writeln;
      Halt;
    END;

  {Initialisierungsdaten aus NODEINFO.CFG lesen.}
  Assign (ParaFile,Dir+'NODEINFO.CFG');
  {$I-} Reset(ParaFile); {$I+}
  IOFehler:=IOResult;
  ParaOK:=True;
  HWDef:=False;
  While (IOFehler=0) AND (NOT EOF(ParaFile)) AND ParaOK DO
    BEGIN
      {$I-} READLN(ParaFile,Ein); {$I+}
      IOFehler:=IOResult;
      IF IOFehler=0 THEN
        BEGIN
          FOR I:=1 TO LENGTH(Ein) DO Ein[I]:=UpCase(Ein[I]);
          IF ParaOK AND (POS('COM=',Ein)=1) THEN
            BEGIN
              Hilf:=COPY(Ein,5,Length(Ein)-4);
              VAL(Hilf,SER,Test);
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('ADRESSE=',Ein)=1) THEN
            BEGIN
              Hilf:=Copy(Ein,9,Length(Ein)-8);
              VAL(Hilf,Adr,Test);
              HWDef:=True;
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('IRQ=',Ein)=1) THEN
            BEGIN
              Hilf:=COPY(Ein,5,Length(Ein)-4);
              VAL(Hilf,IRQ,Test);
              HWDef:=True;
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('BAUDRATE=',Ein)=1) THEN
            BEGIN
              Hilf:=COPY(Ein,10,Length(Ein)-9);
              VAL(Hilf,Baud,Test);
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('BITLAENGE=',Ein)=1) THEN
            BEGIN
              Hilf:=COPY(Ein,11,Length(Ein)-10);
              VAL(Hilf,Bit,Test);
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('PARITAET=',Ein)=1) THEN
            BEGIN
              PARI:=Ein[Length(Ein)];
              ParaOK:=(PARI IN ['G','U','K']);
            END
          ELSE IF ParaOK AND (POS('STOPBIT=',Ein)=1) THEN
            BEGIN
              Hilf:=COPY(Ein,9,Length(Ein)-8);
              VAL(Hilf,STOP,Test);
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('HANDSHAKE=',Ein)=1) THEN
            BEGIN
              HAND:=Ein[Length(Ein)];
              ParaOK:=(HAND IN ['S','H','K']);
            END
          ELSE IF ParaOK AND (POS('ZEICHENSCHUTZZEIT=',Ein)=1) THEN
            BEGIN
              Hilf:=COPY(Ein,19,Length(Ein)-18);
              VAL(Hilf,ZZP,Test);
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('ZEILENSCHUTZZEIT=',Ein)=1) THEN
            BEGIN
              Hilf:=COPY(Ein,18,Length(Ein)-17);
              VAL(Hilf,ZLP,Test);
              ParaOK:=(Test=0);
            END
          ELSE IF ParaOK AND (POS('VIDEORAMAUSGABE=',Ein)=1) THEN
            BEGIN
              DirectVideo:=(Ein[17]='1');
              ParaOK:=(Ein[17] IN ['0','1']);
            END;
        END;
    END;

  IF IOFehler<>0 THEN
    BEGIN
      Writeln;
      Writeln('*** NODEINFO-Abbruch: Fehler bei Zugriff auf NODEINFO.CFG');
      Writeln;
      Halt;
    END;

  Close(ParaFile);

  IF NOT ParaOK THEN
    BEGIN
      Writeln;
      Writeln('*** NODEINFO-Abbruch: Parameterfehler in NODEINFO.CFG');
      Writeln;
      Halt;
    END;

  {Bildschirmmaske aufbauen}
  ClrScr;
  GotoXY(1,2);
  FOR I:=1 to 80 DO Write(#205);
  GotoXY(1,24);
  FOR I:=1 to 80 DO Write(#205);
  GotoXY(1,22);
  FOR I:=1 to 80 DO Write(#205);
  GotoXY(1,25);
  WriteCenter('Beenden Sie das Programm durch Betaetigung der ESC-Taste.');
  Window(1,3,80,21);
  GotoXY(1,1);

  {RS232-Port initialisieren}
  IF HWDef THEN V24DefHW(SER,ADR,IRQ);
  IF V24Install(SER)=False THEN
    BEGIN
      Window(1,1,80,25);
      ClrScr;
      Writeln;
      Writeln('*** NODEINFO Abbruch! COM',SER,' ist nicht vorhanden!');
      Writeln;
      Halt;
    END;
  V24Open(SER,BAUD,BIT,PARI,STOP,HAND);

  {Automatische Abarbeitung der Abfrage}
  GemerktesDatum :=Datum;
  GemerkteZeit   :=Zeit;
  Durchlaeufe    :=1;
  Abfrage        :=1;
  FileForm       :=0;
  RXData         :=False;
  TXData         :=False;
  FehlerAbbruch  :=False;
  ConnectDigi    :='------';
  Digi           :='------';
  Reconnect      :='*';
  IV             :=0;
  Makro          :=True;
  SchleifeAktiv  :=False;

  {Kopfzeile ausgeben}
  HeadLine;
  
  REPEAT
    {Ablaufsteuerdatei fuer Informationsabfrage eroeffnen}
    Assign(CmdFile,CmdName);
    {$I-} Reset (CmdFile); {$I+}
    IF IOResult<>0 THEN
      BEGIN
        Assign(CmdFile,Dir+CmdName);
        {$I-} Reset (CmdFile); {$I+}
        IF IOResult <> 0 THEN
          BEGIN
            Window(1,1,80,25);
            ClrScr;
            Writeln;
            Writeln('*** NODEINFO-Abbruch: Fehler bei Zugriff auf ',CmdName);
            Writeln;
            Halt;
          END;
      END;

    {Kommandodatei fuer Nodeabfrage abarbeiten}    
    V24Write(#24);
    Delay(ZLP);
    Status('Kommandodatei wird abgearbeitet.');
    Zeile         :=1;
    Fehlermeldung :=False;
    LinkFehler    :=False;
    REPEAT
      {$I-} Readln(CmdFile,Ein); {$I+}
      IF IOResult<>0 THEN FileErr(FILENAME(CmdName));
      IF NOT FehlerAbbruch THEN Ablauf(Ein);
      IF (NOT Fehlerabbruch) AND (NOT Linkfehler) THEN INC(Zeile);
    UNTIL EOF(CmdFile) OR FehlerAbbruch OR LinkFehler;
    Close (CmdFile);

    {Offenes RX-File schliessen wenn ***RXCLOSE in Kommandodatei fehlt}
    IF RXData THEN
      BEGIN
        Close (RXFile);
        RXData:=False;
      END;

    {Im Fehlerfall die aktuelle Verbindung disconnecten}
    IF Fehlerabbruch OR Linkfehler THEN
      BEGIN
        V24STWrite(#27+'D');
        WaitStr('CONNECTED');
      END;

    {Zeitabstand abwarten bis zur naechsten Linkstatusabfrage oder Abbruch}
    IF (Durchlaeufe>1) AND NOT Fehlerabbruch THEN
      BEGIN
        INC(Abfrage);
        Pause:=60*IV;
        Ende:=#0;
        REPEAT
          Str(Abfrage,Hilf);
          Aus:='Restzeit bis zur '+Hilf+'. Abfrage ';
          Str(Pause DIV 60,Hilf);
          Aus:=Aus+Hilf+':';
          Str(Pause-((Pause DIV 60)*60),Hilf);
          IF Length(Hilf)=1 THEN Hilf:='0'+Hilf;
          Aus:=Aus+Hilf;
          Status(Aus);
          Ein:=Zeit;
          REPEAT
            Aus:=Zeit;
          UNTIL Aus<>Ein;  {Sekundentakt wird aus Systemuhr abgeleitet}
          V24Input;
          IF Pause >0 THEN DEC (Pause);
          IF KeyPressed THEN IF ReadKey=#27 THEN FehlerAbbruch:=True;
        UNTIL Fehlerabbruch OR (Pause=0);
      END;

    DEC(Durchlaeufe);
  UNTIL FehlerAbbruch OR (Durchlaeufe=0);

  V24Close;
  Window(1,1,80,25);
  ClrScr;

  {Abschlussmeldung des Programms}
  Writeln;
  IF LinkFehler OR FehlerAbbruch THEN
    BEGIN
      Writeln('*** NODEINFO wurde durch den Benutzer oder durch einen Fehler beendet! ***');
      Writeln;
      Writeln('Datum und Uhrzeit     : ',Datum,' ',Zeit);
      Writeln('NODEINFO-Abbruch durch: ',Abbruchursache);
      Writeln('Ablaufsteuerungsdatei : ',CmdName);
      Writeln('Zeile                 : ',Zeile);
      Writeln('Ablaufsteuerungsbefehl: ',Befehl);
      Writeln('Abfragenummer         : ',Abfrage);
    END
  ELSE
    BEGIN
      Writeln('*** NODEINFO wurde normal und fehlerfrei beendet. ***');
      Writeln;
      Writeln('       Datum und Uhrzeit : ',Datum,' ',Zeit);
    END;
  Writeln;
END.
